"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExcelCreator = void 0;
const node_xlsx_1 = __importDefault(require("node-xlsx"));
const sheetExcelCreator_1 = require("./sheetExcelCreator");
const logger_1 = require("../../logger");
class ExcelCreator {
    create(sheets) {
        try {
            logger_1.logger.info("ExcelCreator initiated", { context: sheets });
            const builderSheets = sheets.map((sheet) => new sheetExcelCreator_1.SheetExcelCreator().create(sheet));
            const buffer = node_xlsx_1.default.build(builderSheets);
            logger_1.logger.info("ExcelCreator finished", { context: sheets });
            return buffer;
        }
        catch (error) {
            logger_1.logger.error("ExcelCreator failed", { context: sheets, error });
            throw error;
        }
    }
}
exports.ExcelCreator = ExcelCreator;
