"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SheetExcelParser = void 0;
const constants_1 = require("../constants");
class SheetExcelParser {
    parse(sheet) {
        const headers = this.extractHeadersFromExcelSheet(sheet);
        this.removingEmptyRows(sheet);
        const sheetData = this.typeSheetCells(sheet, headers);
        return sheetData;
    }
    removingEmptyRows(sheet) {
        sheet.data = sheet.data.filter((row) => !row.every((item) => !item));
    }
    extractHeadersFromExcelSheet(sheet) {
        const headers = sheet.data[0];
        sheet.data.shift();
        return headers;
    }
    typeSheetCells(sheet, headers) {
        const sheetData = sheet.data.map((row) => {
            const sheetRow = this.buildExcelResultRow(row, headers);
            return sheetRow;
        });
        return sheetData;
    }
    buildExcelResultRow(row, headers) {
        const buildedRow = {};
        for (const [index, item] of row.entries()) {
            const header = headers[index];
            if (typeof item === "number") {
                const value = parseFloat(item.toString());
                buildedRow[header] = value;
            }
            else {
                buildedRow[header] = item ? item.toString() : constants_1.ITEM_DEFAULT;
            }
        }
        return buildedRow;
    }
}
exports.SheetExcelParser = SheetExcelParser;
