"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.workerfy = void 0;
const worker_threads_1 = require("worker_threads");
function workerfy(workerData) {
    return new Promise((resolve, reject) => {
        const worker = new worker_threads_1.Worker(workerData.path, {
            workerData,
            execArgv: ["-r", "ts-node/register"],
        });
        worker.on("message", (msg) => {
            resolve(msg);
        });
        worker.on("error", (error) => {
            reject(error);
        });
        worker.on("exit", (code) => {
            if (code !== 0)
                reject(new Error(`Worker stopped with exit code ${code}`));
        });
    });
}
exports.workerfy = workerfy;
